# Dictionary Plugin For OpenVerse
# This is by Joshua Kleiner jbk6635@njit.edu
# For more information visit http://OpenVerse.org/
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
#
# This is a frontend for the dict program, http://www.dict.org
# In theory it can be used for any command line program, just change the
# command and enter whatever you want.
#
# To use this plugin, just type '/dict word', without the quotes of course. It
# will then use dict to look up the word and spit out all the definitions and
# annoy everyone in the chat room. It could however be useful if there is an
# argument on what a word means or if you just want to know something.
global Dict

#change the following command to fit your system or program
set Dict(command) "/usr/bin/dict"

# heres the complicated stuff (hah!)

RegisterPlugin Dict ProcessCommand Dict_ProcessCommand


proc Dict_ProcessCommand {original cmd parms rest} {
	global Dict
	if {[string compare [string tolower $cmd] "/dict"]} {return 1}
	set lookup ""
	catch {set lookup [exec $Dict(command) $rest]} err
	set parts [split $lookup "\n"]
	set outstring ""
	foreach part $parts {
		append outstring [string trim $part]
		if {[string length $outstring] > 200} {
			SendToServer "CHAT $outstring"
			set outstring ""
		}
	}
	SendToServer "CHAT $outstring"
	return 0
}

if $MV(debug) {DebugIt "Dict Plugin Initalized!"}

